ies = []
ies.append({ "ie_type" : "Node ID", "ie_value" : "Node ID", "presence" : "M", "tlv_more" : "0", "comment" : "This IE shall contain the unique identifier of the sending Node."})
ies.append({ "ie_type" : "Recovery Time Stamp", "ie_value" : "Recovery Time Stamp", "presence" : "M", "tlv_more" : "0", "comment" : "This IE shall contain the time stamp when the CP or UP function was started, see clause19A of 3GPPTS23.007[24]. (NOTE)"})
ies.append({ "ie_type" : "UP Function Features", "ie_value" : "UP Function Features", "presence" : "C", "tlv_more" : "0", "comment" : "This IE shall be present if the UP function sends this message and the UP function supports at least one UP feature defined in this IE.When present, this IE shall indicate the features the UP function supports."})
ies.append({ "ie_type" : "CP Function Features", "ie_value" : "CP Function Features", "presence" : "C", "tlv_more" : "0", "comment" : "This IE shall be present if the CP function sends this message and the CP function supports at least one CP feature defined in this IE.When present, this IE shall indicate the features the CP function supports."})
type_list["User Plane IP Resource Information"]["max_tlv_more"] = "3"
ies.append({ "ie_type" : "User Plane IP Resource Information", "ie_value" : "User Plane IP Resource Information", "presence" : "O", "tlv_more" : "3", "comment" : "This IE may be present if the UP function sends this message.When present, this IE shall contain an IPv4 and/or an IPv6 address, together with a TEID range that the CP function shall use to allocate GTP-U F-TEID in the UP function.Several IEs with the same IE type may be present to represent multiple User Plane IP Resources."})
ies.append({ "ie_type" : "Alternative SMF IP Address", "ie_value" : "Alternative SMF IP Address", "presence" : "O", "tlv_more" : "0", "comment" : "This IE may be present if the (MB-)SMF advertises the support of the SSET and/or MPAS feature in the CP Function Features IE (see clause8.2.58).When present, this IE shall contain an IPv4 and/or IPv6 address of an alternative (MB-)SMF or an alternative PFCP entity in the same (MB-)SMF when SSET feature is used, or an alternative PFCP entity in the same (MB-)SMF when MPAS feature is used.Several IEs with the same IE type may be present to represent multiple alternative (MB-)SMF IP addresses."})
ies.append({ "ie_type" : "SMF Set ID", "ie_value" : "SMF Set ID", "presence" : "C", "tlv_more" : "0", "comment" : "This IE shall be present if the (MB-)SMF advertises the support of the MPAS feature in the CP Function Features IE (see clause5.22.3).When present, this IE shall contain an FQDN representing the (MB-)SMF set to which the (MB-)SMF belongs. "})
ies.append({ "ie_type" : "PFCP Session Retention Information within PFCP Association Setup Request", "ie_value" : "PFCP Session Retention Information", "presence" : "O", "tlv_more" : "0", "comment" : "This IE may be present to request the UP function to keep all or part of the existing PFCP sessions upon receipt of a PFCP association setup request with a Node ID for which a PFCP association was already established. See clause6.2.6.2.1."})
ies.append({ "ie_type" : "UE IP Address", "ie_value" : "UE IP address Pool Information", "presence" : "O", "tlv_more" : "0", "comment" : "This IE may be present when the UP function sends this message, if UE IP Address Pools are configured in the UP function.Several IE with the same IE type may be present to represent multiple UE IP address Pool Information."})
ies.append({ "ie_type" : "GTP-U Path QoS Control Information", "ie_value" : "GTP-U Path QoS Control Information", "presence" : "C", "tlv_more" : "0", "comment" : "This IE may be present, if the CP function sends this message, to request the UPF to monitor the QoS on GTP-U paths (see clause5.24.5).Several IEs with the same IE type may be present to represent multiple GTP-U paths (with different parameters) to monitor. "})
ies.append({ "ie_type" : "Clock Drift Control Information", "ie_value" : "Clock Drift Control Information", "presence" : "O", "tlv_more" : "0", "comment" : "This IE may be present, if the CP function sends this message, to request the UPF to report clock drift between the external time and 5GS time for working domains (see clause5.26.4).Several IEs with the same IE type may be present for multiple Time domains (with different parameters). "})
ies.append({ "ie_type" : "NF Instance ID", "ie_value" : "UPF Instance ID", "presence" : "O", "tlv_more" : "0", "comment" : "This IE may be present if the UP function is a 5G UP function and if available, and if the message is sent by the UP function."})
ies.append({ "ie_type" : "PFCPASReq-Flags", "ie_value" : "PFCPASReq-Flags", "presence" : "O", "tlv_more" : "0", "comment" : "This IE shall be included if at least one of the flags is set to 1:-	UUPSI (UPF configured for IPUPS): when the message is sent by a UPF, the UP function shall set this flag to 1 if the UPF is configured to be used for IPUPS. See clause5.27."})
msg_list[key]["ies"] = ies
